//
// Project Name: 
//
// Author: 
// Date  : 

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <time.h>
#include <string.h>
#include "graphics2.h"

#define ESC 0x1b

const int MAX_X = 800;
const int MAX_Y = 600;

void drawOpeningScreen();
void drawClosingScreen();

void main() 
{
	srand( (unsigned int) time(NULL));  // Seed the random number generator
	int GraphDriver=0,GraphMode=0;
	initgraph( &GraphDriver, &GraphMode, "", MAX_X, MAX_Y ); // Start Window
	char tempstring[80]="unused";

	// Declare variables
	int mouseX,mouseY;
	bool gameOver;
	bool playAnotherGame;
	bool validResponse;
	char keyPressed;

	//Call a function to draw a fancy title screen
	drawOpeningScreen();
	getch();
	cleardevice();

	playAnotherGame = true;
	while(playAnotherGame) {

		// Start a new game
		cleardevice();

		outtextxy(20,20,"Press ESC or Q to quit Game.");

		gameOver=false;
		while (gameOver==false) {

			//Main part of the game goes here

			// Check keyboard
			if (kbhit()) {
				keyPressed=getch();

				switch(keyPressed) {
				case ESC: case 'q': case 'Q':
					//Quit
					gameOver = true;
					break;
				default:
					// Unrecognized key, do nothing
					break;
				}
			} // end of if kbhit

			// Check mouse
			if ( mouseup() ) {
				mouseX = mouseclickx();
				mouseY = mouseclicky();
			} // end of if mouseup

			//at end of main game loop (while gameOver==false)
			delay(50);
		}

		//Game Over.  Ask if they want to play again
		setcolor(YELLOW);
		outtextxy(25, 425, "Game Over. Play again? (Y/N)");
		validResponse=false;
		do {
			keyPressed = getch();
			if ((keyPressed=='y') || (keyPressed=='Y')) {
					playAnotherGame = true;
					validResponse=true;
			}
			if ((keyPressed=='n') || (keyPressed=='N') || (keyPressed==ESC)) {
					playAnotherGame = false;
					validResponse=true;
			}
		} while (validResponse==false);

	}
	drawClosingScreen();

	getch(); //Wait for a key. (When main function ends, the window will close)
} // end of main()

void drawOpeningScreen() {
	setcolor(LIGHTGRAY);
	setfillstyle(SOLID_FILL,LIGHTGRAY);
	bar(110,110, 550, 350);

	setcolor(BLUE);
	setfillstyle(SOLID_FILL,BLUE);
	bar(100,100, 540, 340);

	setcolor(WHITE);
	settextstyle(TRIPLEX_FONT, HORIZ_DIR, 2);
	outtextxy(180, 150, "Welcome to BLANK");
	outtextxy(180, 170, "by CSCI105 Student");

	outtextxy(300, 440, "Press any key...");
}

void drawClosingScreen() {
	cleardevice();

	setcolor(RED);
	outtextxy(180, 150, "Thanks for playing");

	setcolor(WHITE);
	outtextxy(300, 440, "Press any key to quit...");
}
